/******************************************************************************
* FILE: hello.c
* DESCRIPTION:
*   A "hello world" Pthreads program.  Demonstrates thread creation and
*   termination.
* AUTHOR: Blaise Barney
* LAST REVISED: 04/05/05
******************************************************************************/
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#define NUM_THREADS	5

/*
You will need to call pthread_win32_process_attach_np() before
you can call any pthread routines when statically linking.
You should call pthread_win32_process_detach_np() before
exiting your application to clean up.
*/
/*
Set C/C++->General->Detect 64 Bit Portability Issus to "false" to aviod warnings
(this will remove /Wp64 from compiler options)
*/

void *PrintHello(void *threadid)
{
	int i, j = rand()*rand()*rand();
	for (i = 0; i < j; i++)
		i++;
	printf("\n%d: Hello World!\n", threadid);
	pthread_exit(NULL);
	return 0;
}

int main(int argc, char *argv[])
{
	pthread_t threads[NUM_THREADS];
	int rc, t, i, j = rand()*rand()*100;

	pthread_win32_process_attach_np();

	for(t=0;t<NUM_THREADS;t++)
	{
		printf("Creating thread %d\n", t);
		rc = pthread_create(&threads[t], NULL, PrintHello, (void *)t);
		for (i = 0; i < j; i++)
			i++;

		if (rc)
		{
			printf("ERROR; return code from pthread_create() is %d\n", rc);
			exit(-1);
		}
	}
	pthread_exit(NULL);

	pthread_win32_process_detach_np();
}
